use utf8;
( # dyadic, monadic

# arithmetic
["+\n-", "add\nSum of A and B", "conjugate\nNo change to B"],
["−\n_", "subtract\nA minus B", "negate\nChanges sign of B"],
["×\n-", "multiply\nA multiplied by B", "sign\n¯1 if B<0; 0 if B=0; 1 if B>0"],
["÷\n=", "divide\nA divided by B", "reciprocal\n1 divided by B"],
["∣\nm", "residue\nRemainder of division: B modulo A", "magnitude\nAbsolute value of B"],
["⋆\np", "power\nA raised to the B power", "exponential\ne to the B power"],
["⍟\n*", "logarithm\nLogarithm of B to base A", "natural logarithm\nNatural logarithm of B"],
["○\no", "circle\nTrigonometric functions of B selected by A\nA=1: sin(B) A=2: cos(B) A=3: tan(B)", "pi times\nMultiply by π"],
["⌈\ns", "maximum\nThe greater value of A or B", "ceiling\nLeast integer greater than or equal to B"],
["⌊\nd", "minimum\nThe smaller value of A or B", "floor\nGreatest integer less than or equal to B"],
["!", "binomial\nNumber of combinations of B taken A at a time", "factorial\nProduct of integers 1 to B"],
["?\nq", "deal\nA distinct integers selected randomly from the first B integers", "roll\nOne integer selected randomly from the first B integers"],

undef,

# logical
["∼\nt", "difference\nItems found in B are removed from A", "not\nLogical: ∼1 is 0, ∼0 is 1"],
["∨\n9", "or\nLogic: 0 if A and B are 0; 1 otherwise"],
["∧\n0", "and\nLogic: 1 if A and B are 1; 0 otherwise"],
["⍱\n(", "nor\nLogic: 1 if both A and B are 0; otherwise 0"],
["⍲\n)", "nand\nLogic: 0 if both A and B are 1; otherwise 1"],

# comparative
["<\n3", "less than\nComparison: 1 if true, 0 if false"],
["≤\n4", "less than or equal\nComparison: 1 if true, 0 if false"],
["=\n5", "equal\nComparison: 1 if true, 0 if false"],
["≥\n6", "greater than or equal\nComparison: 1 if true, 0 if false"],
[">\n7", "greater than\nComparison: 1 if true, 0 if false"],
["≠\n8", "not equal\nComparison: 1 if true, 0 if false"],
["≡\n:", "match\n1 if arguments are the same in every respect, 0 if not", "depth\nLevel of nesting: 1 + maximum array depth or 0 if scalar"],
["≢\n\"", "not match\n1 if arguments are different if any respect, 0 if not", "tally\nNumber of major cells in B, equivalent to {⍬⍴ (⍴⍵),1}"],

undef,

# vector
["∈\ne", "membership\n1 for elements of A present in B; 0 where not", "enlist\nEvery element in B as simple vector"],
["⍷\nE", "find\nElements of A within B, returning 1 if the start of A is found in B"],
["⌷\nL", "index", "materialise"],
["⍬\n}", undef, "zilde\nEmpty numeric vector, equivalent to ⍳0 or 0⍴0"],
["⍳\ni", "index of\nThe location (index) of B in A; 1+⌈/⍳⍴A if not found", "count\nVector of the first B integers"],
["⍸\nI", "string index\nThe index of B in A using ⍷ as primary function"],
["⍴\nr", "reshape\nArray of shape A with data B", "shape\nNumber of components in each dimension of B"],

# selection
["⊢\n\\", "right\nDiscard A and pass B unchanged", "pass\nPasses argument unchanged, useful to force display of non-printing result"],
["⊣\n|", "left\nDiscard B and pass A unchanged", "stop\nDiscard argument and return empty matrix"],
["⋄\n`", "statement separator\nSeparates multiple statements on a single line"],
["↑\ny", "take\nSelect the first (or last) A elements of B according to ×A", "nub"],
["↓\nu", "drop\nRemove the first (or last) A elements of B according to ×A", "split"],

# set
["⊂\nz", "partition\nDivide B into an array of vectors according to specification in A", "enclose\nProduce a scalar of vector B"],
["⊃\nx", "pick\nSelect item A from vector B", "disclose\nProduce an array made up of the items in B"],
["⊆", "subset\nElements in both A and B: (∧/A∈B)∧(∧/B∈A)"],
["∩\nc", "intersection\nElements of A that are in B: (A∈B)/A"],
["∪\nv", "union\nCatenate A and B determined by combining ranks: A,(∼A∈B)/A", "unique"],
[",", "catenate\nElements of B appended to the elements of A", "ravel\nReshapes B into a vector"],
["⍪\n<", "catenate first\nCatenate across the first axis"],

# transform
["⌹\n+", "matrix divide\nSolution to system of linear equations, multiple regression Ax = B", "matrix inverse\nInverse of matrix B"],
["⌽\n%", "rotate first\nThe elements of B are rotated A positions", "reverse first\nReverse elements of B along last axis"],
["⊖\n&", "rotate\nThe elements of B are rotated A positions along the first axis", "reverse\nReverse elements of B along first axis"],
["⍉\n^", "general transpose\nThe axes of B are ordered by A", "monadic transpose\nReverse the axes of B"],

undef,

# sorting and coding
["⍋\n\$", "grade up\nArrange B according to collating sequence specified by A", "grade up\nIndices of B which will arrange B in ascending order"],
["⍒\n#", "grade down\nArrange B according to inverse collating sequence specified by A", "grade down\nIndices of B which will arrange B in descending order"],
["⊤\nn", "encode\nBase-A representation of the value of B"],
["⊥\nb", "decode\nValue of a polynomial whose coefficients are B at A"],

# miscellaneous
["⍺", "picture format\nDisplays the numbers in B according to the instructions in A", "alpha"],
["⍕\n'", "specified format\nFormat B into a character matrix according to A", "format\nConvert to characters according to default display rules"],
["⍎\n;", "execute", "execute\nExecute an APL expression"],
["⎕\nl", undef, "evaluated I/O\nRead number or expression typed on the keyboard or display result with newline"],
["⍞\n{", undef, "bare I/O\nRead data typed on the keyboard as characters or display without terminating newline"],
[")", undef, "hook"],
["→\n]", undef, "goto\n→This_Label sends APL execution to This_Label:"],
["←\n[", undef, "assign\nB←A sets values and shape of B to match A"],
["⍝\n,", undef, "comment\nEverything to the right of ⍝ denotes a comment"],

["_\nf"],
["∆\nh", "difference", "derivative"],
["∇\ng", undef, "edit\nToggle function definition mode"],
["⍫\n@", undef, "lock\nEdit a function which cannot be edited or displayed"],
["'\nk"],
["⍙\n>"],

undef,

# operators
["\\","expand\nInsert zeros (or blanks) in B corresponding to zeros in A", "scan\nRunning sum across B"],
["⍀\n.", "expand first", "scan first\nRunning sum down B"],
["/", "replicate\nSelect elements in B corresponding to ones in A", "reduce\nSum across B"],
["⌿\n/", "replicate first", "reduce first\nSum down B"],

# array
["¯\n2", undef, "negative\nDenotes a negative number"],
["∝\na"],
["⍵\nw", "omega"],

# monadic
["¨\n1", "each\nOver each, or perform each separately; B = on these; A = operation to perform or using (e.g. iota)"],
["⍨\nT", "commute\nExchanges the arguments of a dyadic function: A+⍨B ↔ B+A"],
["&", undef, "spawn"],
["⌶\n!", undef, "I-beam"],

# dyadic
["⍠\n?", "variant"],
["⌸", "key\nApply function to each unique key in A and major cells of B having that key", "key\nApply function A to each unique key in B and elements of ⍳≢B having that key"],
["⍣\nP", "reapply\nThe function A is applied B times"],
[".", "inner product\nMatrix product of A and B"],
["∘.\nj", "outer product\nOuter product of A and B"],
["∘\nj", "compose"],
["⍤\nJ", "rank\nApply function successively to the sub-arrays in B specified by k"],
["⍥\nO", "coax"],

);
